#ifdef GL_ES
precision mediump float;
#endif

#ifdef GL_ES
precision lowp float;
#endif

varying vec4        v_fragmentColor;
varying vec2        v_texCoord;

//グレスケ用変数
const float gRed    = 0.3;
const float gGreen  = 0.6;
const float gBlue   = 0.1;
const vec3  gScale  = vec3(gRed, gGreen, gBlue);

uniform float u_rate;


void main()
{
    vec4  baseColor = texture2D(CC_Texture0, v_texCoord);
    float grayColor = dot(baseColor.rgb, gScale);
    
    vec4 ansColor = vec4(vec3(grayColor), baseColor.a);
    vec4 blendColor = vec4(baseColor.rgb * u_rate, baseColor.a);
    
    ansColor = ansColor * (1.0 - u_rate);
    ansColor = ansColor + blendColor;
    
    gl_FragColor = ansColor * v_fragmentColor.a;
}