#ifdef GL_ES
precision mediump float;
#endif

#ifdef GL_ES
precision lowp float;
#endif

varying vec4        v_fragmentColor;
varying vec2        v_texCoord;

//加算用変数
uniform vec4		color_v4;

//グレスケ用変数
const float gRed    = 0.3;
const float gGreen  = 0.6;
const float gBlue   = 0.1;
const vec3  gScale  = vec3(gRed, gGreen, gBlue);

uniform float u_rate;

//ネガポジ変換
uniform float nega_rate;


void main()
{
    //グレスケ
    vec4  baseColor = texture2D(CC_Texture0, v_texCoord);
    float grayColor = dot(baseColor.rgb, gScale);
    
    vec4 ansColor = vec4(vec3(grayColor), baseColor.a);
    vec4 blendColor = vec4(baseColor.rgb * u_rate, baseColor.a);
    
    ansColor = ansColor * (1.0 - u_rate) + blendColor;
    
    //ネガ反転
    ansColor.r = ansColor.r * (1.0 - nega_rate) + (1.0 - ansColor.r) * nega_rate * ansColor.a;
    ansColor.g = ansColor.g * (1.0 - nega_rate) + (1.0 - ansColor.g) * nega_rate * ansColor.a;
    ansColor.b = ansColor.b * (1.0 - nega_rate) + (1.0 - ansColor.b) * nega_rate * ansColor.a;
    
    //加算
    vec4 src = v_fragmentColor * ansColor * v_fragmentColor.a;
    gl_FragColor = src + color_v4 * src.w;
    
}

