
////varying vec4 v_fragmentColor;
////varying vec2 v_texCoord;
////
////
////void main(void)
////{
////	gl_FragColor = vec4(0.3, 0.1, 0.0, 0.5); // Red.
////}
//
//
//#ifdef GL_ES
//precision mediump float;
//#endif
//
//varying vec2 v_texCoord;
//uniform sampler2D u_texture;
//
//void main()
//{
////	vec4 normalColor = texture2D(u_texture, v_texCoord);
////	float r = normalColor.r;
////	float g = normalColor.g;
////	float b = normalColor.b;
////	float sepiaDepth = 17.0;
////	float sepiaIntensity = 23.0;
////	if(normalColor.a >= 64.0/255.0)
////	{
////		float gray = (0.2 * normalColor.r) + (0.7 * normalColor.g) + (0.1 * normalColor.b);
////		r = gray+2.0*sepiaDepth/255.0;
////		if(r>1.0)
////			r = 1.0;
////		g = gray+sepiaDepth/255.0;
////		if(g>1.0)
////			g = 1.0;
////		
////		b = gray-sepiaIntensity/255.0;
////		if(b>1.0)
////			b = 1.0;
////		if(b<0.0)
////			b = 0.0;
////	}
////	gl_FragColor = vec4(r, g, b, normalColor.a);
//	
//	gl_FragColor =  texture2D(u_texture, v_texCoord);
//}


//コピペのガウシアンフィルタ

#ifdef GL_ES
precision mediump float;
#endif

varying vec2        v_texCoord;
uniform sampler2D   u_texture;
uniform vec2        u_texSize;
uniform int         u_mosaicLevel;

varying lowp vec4   v_fragmentColor;
uniform vec2        pixelSize;
uniform vec2        direction;
uniform int         radius;
uniform vec2        weights[64];

void main() {
	vec4 sum = texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y)) * weights[0].x;
	int rad = 40;
	for(int i = 1; i < rad; i++){
		vec2 offset = vec2(float(i) * pixelSize.x * direction.x, float(i) * pixelSize.y * direction.y);
		sum += texture2D(u_texture, v_texCoord + offset) * weights[i].x;
		sum += texture2D(u_texture, v_texCoord - offset) * weights[i].x;
	}
	gl_FragColor = sum * v_fragmentColor;
}
